# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['SecurityPolicyArgs', 'SecurityPolicy']

@pulumi.input_type
class SecurityPolicyArgs:
    def __init__(__self__, *,
                 entity: pulumi.Input[str],
                 zone_id: pulumi.Input[str],
                 config: Optional[pulumi.Input['SecurityPolicyConfigArgs']] = None):
        """
        The set of arguments for constructing a SecurityPolicy resource.
        :param pulumi.Input[str] entity: Subdomain.
        :param pulumi.Input[str] zone_id: Site ID.
        :param pulumi.Input['SecurityPolicyConfigArgs'] config: Security policy configuration.
        """
        pulumi.set(__self__, "entity", entity)
        pulumi.set(__self__, "zone_id", zone_id)
        if config is not None:
            pulumi.set(__self__, "config", config)

    @property
    @pulumi.getter
    def entity(self) -> pulumi.Input[str]:
        """
        Subdomain.
        """
        return pulumi.get(self, "entity")

    @entity.setter
    def entity(self, value: pulumi.Input[str]):
        pulumi.set(self, "entity", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Input[str]:
        """
        Site ID.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "zone_id", value)

    @property
    @pulumi.getter
    def config(self) -> Optional[pulumi.Input['SecurityPolicyConfigArgs']]:
        """
        Security policy configuration.
        """
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: Optional[pulumi.Input['SecurityPolicyConfigArgs']]):
        pulumi.set(self, "config", value)


@pulumi.input_type
class _SecurityPolicyState:
    def __init__(__self__, *,
                 config: Optional[pulumi.Input['SecurityPolicyConfigArgs']] = None,
                 entity: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SecurityPolicy resources.
        :param pulumi.Input['SecurityPolicyConfigArgs'] config: Security policy configuration.
        :param pulumi.Input[str] entity: Subdomain.
        :param pulumi.Input[str] zone_id: Site ID.
        """
        if config is not None:
            pulumi.set(__self__, "config", config)
        if entity is not None:
            pulumi.set(__self__, "entity", entity)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter
    def config(self) -> Optional[pulumi.Input['SecurityPolicyConfigArgs']]:
        """
        Security policy configuration.
        """
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: Optional[pulumi.Input['SecurityPolicyConfigArgs']]):
        pulumi.set(self, "config", value)

    @property
    @pulumi.getter
    def entity(self) -> Optional[pulumi.Input[str]]:
        """
        Subdomain.
        """
        return pulumi.get(self, "entity")

    @entity.setter
    def entity(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "entity", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Site ID.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)


class SecurityPolicy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config: Optional[pulumi.Input[pulumi.InputType['SecurityPolicyConfigArgs']]] = None,
                 entity: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a teo security_policy

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        security_policy = tencentcloud.teo.SecurityPolicy("securityPolicy",
            config=tencentcloud.teo.SecurityPolicyConfigArgs(
                acl_config=tencentcloud.teo.SecurityPolicyConfigAclConfigArgs(
                    switch="off",
                ),
                bot_config=tencentcloud.teo.SecurityPolicyConfigBotConfigArgs(
                    intelligence_rule=tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleArgs(
                        items=[
                            tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleItemArgs(
                                action="drop",
                                label="evil_bot",
                            ),
                            tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleItemArgs(
                                action="alg",
                                label="suspect_bot",
                            ),
                            tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleItemArgs(
                                action="monitor",
                                label="good_bot",
                            ),
                            tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleItemArgs(
                                action="trans",
                                label="normal",
                            ),
                        ],
                        switch="off",
                    ),
                    managed_rule=tencentcloud.teo.SecurityPolicyConfigBotConfigManagedRuleArgs(
                        action="monitor",
                        alg_managed_ids=[],
                        cap_managed_ids=[],
                        drop_managed_ids=[],
                        mon_managed_ids=[],
                        page_id=0,
                        punish_time=0,
                        response_code=0,
                        rule_id=0,
                        trans_managed_ids=[],
                    ),
                    portrait_rule=tencentcloud.teo.SecurityPolicyConfigBotConfigPortraitRuleArgs(
                        alg_managed_ids=[],
                        cap_managed_ids=[],
                        drop_managed_ids=[],
                        mon_managed_ids=[],
                        rule_id=-1,
                        switch="off",
                    ),
                    switch="off",
                ),
                drop_page_config=tencentcloud.teo.SecurityPolicyConfigDropPageConfigArgs(
                    acl_drop_page_detail=tencentcloud.teo.SecurityPolicyConfigDropPageConfigAclDropPageDetailArgs(
                        name="-",
                        page_id=0,
                        status_code=569,
                        type="default",
                    ),
                    switch="on",
                    waf_drop_page_detail=tencentcloud.teo.SecurityPolicyConfigDropPageConfigWafDropPageDetailArgs(
                        name="-",
                        page_id=0,
                        status_code=566,
                        type="default",
                    ),
                ),
                except_config=tencentcloud.teo.SecurityPolicyConfigExceptConfigArgs(
                    switch="on",
                ),
                ip_table_config=tencentcloud.teo.SecurityPolicyConfigIpTableConfigArgs(
                    switch="off",
                ),
                rate_limit_config=tencentcloud.teo.SecurityPolicyConfigRateLimitConfigArgs(
                    intelligence=tencentcloud.teo.SecurityPolicyConfigRateLimitConfigIntelligenceArgs(
                        action="monitor",
                        switch="off",
                    ),
                    switch="on",
                    template=tencentcloud.teo.SecurityPolicyConfigRateLimitConfigTemplateArgs(
                        detail=tencentcloud.teo.SecurityPolicyConfigRateLimitConfigTemplateDetailArgs(
                            action="alg",
                            id=831807989,
                            mode="sup_loose",
                            period=1,
                            punish_time=0,
                            threshold=2000,
                        ),
                        mode="sup_loose",
                    ),
                ),
                switch_config=tencentcloud.teo.SecurityPolicyConfigSwitchConfigArgs(
                    web_switch="on",
                ),
                waf_config=tencentcloud.teo.SecurityPolicyConfigWafConfigArgs(
                    ai_rule=tencentcloud.teo.SecurityPolicyConfigWafConfigAiRuleArgs(
                        mode="smart_status_close",
                    ),
                    level="strict",
                    mode="block",
                    switch="on",
                    waf_rules=tencentcloud.teo.SecurityPolicyConfigWafConfigWafRulesArgs(
                        block_rule_ids=[
                            22,
                            84214562,
                            106246133,
                            106246507,
                            106246508,
                            106246523,
                            106246524,
                            106246679,
                            106247029,
                            106247048,
                            106247140,
                            106247356,
                            106247357,
                            106247358,
                            106247378,
                            106247389,
                            106247392,
                            106247394,
                            106247405,
                            106247409,
                            106247413,
                            106247558,
                            106247795,
                            106247819,
                            106248021,
                        ],
                        observe_rule_ids=[],
                        switch="off",
                    ),
                ),
            ),
            entity="aaa.sfurnace.work",
            zone_id="zone-2983wizgxqvm")
        ```

        ## Import

        teo security_policy can be imported using the zoneId#entity, e.g.

        ```sh
         $ pulumi import tencentcloud:Teo/securityPolicy:SecurityPolicy security_policy zone-2983wizgxqvm#aaa.sfurnace.work
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['SecurityPolicyConfigArgs']] config: Security policy configuration.
        :param pulumi.Input[str] entity: Subdomain.
        :param pulumi.Input[str] zone_id: Site ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SecurityPolicyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a teo security_policy

        ## Example Usage

        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        security_policy = tencentcloud.teo.SecurityPolicy("securityPolicy",
            config=tencentcloud.teo.SecurityPolicyConfigArgs(
                acl_config=tencentcloud.teo.SecurityPolicyConfigAclConfigArgs(
                    switch="off",
                ),
                bot_config=tencentcloud.teo.SecurityPolicyConfigBotConfigArgs(
                    intelligence_rule=tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleArgs(
                        items=[
                            tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleItemArgs(
                                action="drop",
                                label="evil_bot",
                            ),
                            tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleItemArgs(
                                action="alg",
                                label="suspect_bot",
                            ),
                            tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleItemArgs(
                                action="monitor",
                                label="good_bot",
                            ),
                            tencentcloud.teo.SecurityPolicyConfigBotConfigIntelligenceRuleItemArgs(
                                action="trans",
                                label="normal",
                            ),
                        ],
                        switch="off",
                    ),
                    managed_rule=tencentcloud.teo.SecurityPolicyConfigBotConfigManagedRuleArgs(
                        action="monitor",
                        alg_managed_ids=[],
                        cap_managed_ids=[],
                        drop_managed_ids=[],
                        mon_managed_ids=[],
                        page_id=0,
                        punish_time=0,
                        response_code=0,
                        rule_id=0,
                        trans_managed_ids=[],
                    ),
                    portrait_rule=tencentcloud.teo.SecurityPolicyConfigBotConfigPortraitRuleArgs(
                        alg_managed_ids=[],
                        cap_managed_ids=[],
                        drop_managed_ids=[],
                        mon_managed_ids=[],
                        rule_id=-1,
                        switch="off",
                    ),
                    switch="off",
                ),
                drop_page_config=tencentcloud.teo.SecurityPolicyConfigDropPageConfigArgs(
                    acl_drop_page_detail=tencentcloud.teo.SecurityPolicyConfigDropPageConfigAclDropPageDetailArgs(
                        name="-",
                        page_id=0,
                        status_code=569,
                        type="default",
                    ),
                    switch="on",
                    waf_drop_page_detail=tencentcloud.teo.SecurityPolicyConfigDropPageConfigWafDropPageDetailArgs(
                        name="-",
                        page_id=0,
                        status_code=566,
                        type="default",
                    ),
                ),
                except_config=tencentcloud.teo.SecurityPolicyConfigExceptConfigArgs(
                    switch="on",
                ),
                ip_table_config=tencentcloud.teo.SecurityPolicyConfigIpTableConfigArgs(
                    switch="off",
                ),
                rate_limit_config=tencentcloud.teo.SecurityPolicyConfigRateLimitConfigArgs(
                    intelligence=tencentcloud.teo.SecurityPolicyConfigRateLimitConfigIntelligenceArgs(
                        action="monitor",
                        switch="off",
                    ),
                    switch="on",
                    template=tencentcloud.teo.SecurityPolicyConfigRateLimitConfigTemplateArgs(
                        detail=tencentcloud.teo.SecurityPolicyConfigRateLimitConfigTemplateDetailArgs(
                            action="alg",
                            id=831807989,
                            mode="sup_loose",
                            period=1,
                            punish_time=0,
                            threshold=2000,
                        ),
                        mode="sup_loose",
                    ),
                ),
                switch_config=tencentcloud.teo.SecurityPolicyConfigSwitchConfigArgs(
                    web_switch="on",
                ),
                waf_config=tencentcloud.teo.SecurityPolicyConfigWafConfigArgs(
                    ai_rule=tencentcloud.teo.SecurityPolicyConfigWafConfigAiRuleArgs(
                        mode="smart_status_close",
                    ),
                    level="strict",
                    mode="block",
                    switch="on",
                    waf_rules=tencentcloud.teo.SecurityPolicyConfigWafConfigWafRulesArgs(
                        block_rule_ids=[
                            22,
                            84214562,
                            106246133,
                            106246507,
                            106246508,
                            106246523,
                            106246524,
                            106246679,
                            106247029,
                            106247048,
                            106247140,
                            106247356,
                            106247357,
                            106247358,
                            106247378,
                            106247389,
                            106247392,
                            106247394,
                            106247405,
                            106247409,
                            106247413,
                            106247558,
                            106247795,
                            106247819,
                            106248021,
                        ],
                        observe_rule_ids=[],
                        switch="off",
                    ),
                ),
            ),
            entity="aaa.sfurnace.work",
            zone_id="zone-2983wizgxqvm")
        ```

        ## Import

        teo security_policy can be imported using the zoneId#entity, e.g.

        ```sh
         $ pulumi import tencentcloud:Teo/securityPolicy:SecurityPolicy security_policy zone-2983wizgxqvm#aaa.sfurnace.work
        ```

        :param str resource_name: The name of the resource.
        :param SecurityPolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SecurityPolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config: Optional[pulumi.Input[pulumi.InputType['SecurityPolicyConfigArgs']]] = None,
                 entity: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SecurityPolicyArgs.__new__(SecurityPolicyArgs)

            __props__.__dict__["config"] = config
            if entity is None and not opts.urn:
                raise TypeError("Missing required property 'entity'")
            __props__.__dict__["entity"] = entity
            if zone_id is None and not opts.urn:
                raise TypeError("Missing required property 'zone_id'")
            __props__.__dict__["zone_id"] = zone_id
        super(SecurityPolicy, __self__).__init__(
            'tencentcloud:Teo/securityPolicy:SecurityPolicy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config: Optional[pulumi.Input[pulumi.InputType['SecurityPolicyConfigArgs']]] = None,
            entity: Optional[pulumi.Input[str]] = None,
            zone_id: Optional[pulumi.Input[str]] = None) -> 'SecurityPolicy':
        """
        Get an existing SecurityPolicy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['SecurityPolicyConfigArgs']] config: Security policy configuration.
        :param pulumi.Input[str] entity: Subdomain.
        :param pulumi.Input[str] zone_id: Site ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SecurityPolicyState.__new__(_SecurityPolicyState)

        __props__.__dict__["config"] = config
        __props__.__dict__["entity"] = entity
        __props__.__dict__["zone_id"] = zone_id
        return SecurityPolicy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def config(self) -> pulumi.Output['outputs.SecurityPolicyConfig']:
        """
        Security policy configuration.
        """
        return pulumi.get(self, "config")

    @property
    @pulumi.getter
    def entity(self) -> pulumi.Output[str]:
        """
        Subdomain.
        """
        return pulumi.get(self, "entity")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[str]:
        """
        Site ID.
        """
        return pulumi.get(self, "zone_id")

